Đến nội dung


Hình ảnh
- - - - -

[Yêu cầu] Xin được giúp đỡ về LISP sử lý chuỗi.


  • Please log in to reply
7 replies to this topic

#1 12123

12123

    Chưa sử dụng CAD

  • Members
  • Pip
  • 3 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 17 July 2012 - 11:02 AM

Em là lính mới - mong anh chị em giúp cho điều này!

giải sử chúng ta đã tính toán ra một giá trị nào đó trước và gán cho A (mang giá trị abc)

...... (setq A (... kết quả quá trình tính toán... ---> abc)).....


có một chuỗi có sẵn trong bản vẽ có dạng: 123a456b789c (ví dụ vậy!)


Em muốn các anh chị giúp em: Viết đoạn LISP để "gán giá trị của A (là abc) vào chuỗi mới sau b để thay thế cho 789" trở thành: 123a456babcc, abc thay thế trọn vẹn cho 789, giả sử có là 7891.. . vẫn chỉ thay bằng abc mà thôi!

Mong chờ câu trả lời của anh chị! Xin cám ơn!
  • 0

#2 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 17 July 2012 - 11:21 AM

Bạn nghiên cứu hàm vl-string-subst
Cú pháp : (vl-string-subst chuỗi_mới chuỗi_cũ chuỗi_tổng)
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#3 phamthanhbinh

phamthanhbinh

    biết lệnh adcenter

  • Moderator
  • PipPipPipPipPipPipPip
  • 6009 Bài viết
Điểm đánh giá: 3113 (tuyệt vời)

Đã gửi 17 July 2012 - 11:51 AM

Em là lính mới - mong anh chị em giúp cho điều này!

giải sử chúng ta đã tính toán ra một giá trị nào đó trước và gán cho A (mang giá trị abc)

...... (setq A (... kết quả quá trình tính toán... ---> abc)).....


có một chuỗi có sẵn trong bản vẽ có dạng: 123a456b789c (ví dụ vậy!)


Em muốn các anh chị giúp em: Viết đoạn LISP để "gán giá trị của A (là abc) vào chuỗi mới sau b để thay thế cho 789" trở thành: 123a456babcc, abc thay thế trọn vẹn cho 789, giả sử có là 7891.. . vẫn chỉ thay bằng abc mà thôi!

Mong chờ câu trả lời của anh chị! Xin cám ơn!

Hề hề hề,'
Bạn hãy xem đoạn code sau và từ đó lọc lấy cách dùng cho phù hợp với từng trường hợp cụ thể của bạn.
(setq a "123a456b789c")
(setq i (1+ (vl-string-search "b" a))
j (1+ (vl-string-search "c" a))
b (strcat (substr a 1 i) "abc" (substr a j))
)
  • 0
Chúc các quý Anh trên diễn đàn luôn khỏe, đẻ thêm được nhiều thứ để mót.

#4 lý nhẹ

lý nhẹ

    biết zoom

  • Members
  • Pip
  • 11 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 17 July 2012 - 05:44 PM

Trước tiên xin được cám ơn tấm chân tình của các đại ka: ketxuphamthanhbinh đã có lòng tương cứu!

Như em đã nói là text cần hiệu chỉnh đã có sẵn trong bản vẽ có dạng: ...a...b...c, chúng ta có thể gọi lên bằng "select object"
Ví dụ đoạn code như sau:


(defun C:12345()
(setq a (getreal "/n Cho biet a:")
b (getreal "/n Cho biet b:")
c (getreal "/n Cho biet c:")
del (- (* b B)(* 4 a c))
)
(setq strdel (rtos del 2 3))
(setq texthc (car (entsel "/n Chon text can hieu chinh")))
(setq i (+ 1 (vl-string-search "b" texthc))
j (+ 1 (vl-string-search "c" texthc))
texthc (strcat (substr texthc1 i) strdel (substr texthc j))
(princ)
)
nhưng đã làm không được các bác ạ!
  • 0

#5 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 17 July 2012 - 08:48 PM

texthc đang là 1 ename, có phải là string đâu mà bạn dùng các lệnh thao tác với string ??
Tốt nhất bạn nên viết hàm con cho nó. Ví dụ như thế này :


(defun change_txt (e new old)
(cond
( (wcmatch (cdadr (entget e)) "*TEXT")
(vl-load-com)
(vla-put-textstring (setq e(vlax-ename->vla-object e)) (vl-string-subst new old (vla-get-textstring e)))
)
)
)
Sau đó gọi như sau :
(change_txt (car(entsel)) "Chuỗi_mới" "Chuỗi_cũ")
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC


#6 lý nhẹ

lý nhẹ

    biết zoom

  • Members
  • Pip
  • 11 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 18 July 2012 - 12:04 AM

Xin lỗi anh ketxu! Tui không hiểu gì về nhóm hàm VL- và VLA- nên không biết ý nghĩa đoạn chương trình con của anh! Khi chép về và load lên chạy thử hàm con (change_txt) thì CAD báo lỗi: ; error: too few arguments ---> kiểm tra đâu thấy thiếu Space nào?!
Một điều nữa: (change_txt (car(entsel)) "Chuỗi_mới" "Chuỗi_cũ") ---> chuỗi mới và chuỗi cũ là gì vậy anh? Vậy thì hàm (change_txt) không thay đổi kiểu dữ liệu!

Chúng ta đang cần định nghĩa một hàm con chuyển kiểu dữ liệu từ text chọn vào sang kiểu string mà? Anh có thể thiết kế một hàm con như thế không? Cám ơn anh rất nhiều!
  • 0

#7 lý nhẹ

lý nhẹ

    biết zoom

  • Members
  • Pip
  • 11 Bài viết
Điểm đánh giá: 0 (bình thường)

Đã gửi 18 July 2012 - 01:57 AM

Em hiểu rùi, chúng ta cần bổ xung thêm hàm con này nữa là xử lý được:
(defun moddxf (dxf chdxf ss) (entmod (subst (cons dxf chdxf) (assoc dxf (entget ss)) (entget ss))))
  • 0

#8 ketxu

ketxu

    Copier - Paster - Editor

  • Moderator
  • PipPipPipPipPipPipPip
  • 5682 Bài viết
Điểm đánh giá: 2605 (tuyệt vời)

Đã gửi 18 July 2012 - 08:01 AM

@lý nhẹ : mình k hiểu là bạn đã biết dùng hàm con chưa, khi mà hàm của mình có 3 đối số bạn chép được mỗi cái tên hàm => nó chẳng báo thiếu đối số ^^
Hàm mình viết bên trên cho phép bạn edit text luôn rồi, còn thay đổi chi nữa :)
- Hàm lấy dữ liệu string từ text trên bản vẽ :
Lisp :

(defun noidung (e)(cdr(assoc 1 (entget e))))

- Đối số : ename
- Gọi : (noidung (car (entsel)))

Visual lisp :

(defun noidung(e)(vla-get-textstring (vlax-ename->vla-object e)))


- Đối số : ename
- Gọi : (noidung (car (entsel)))
  • 0

Thành viên nhóm CadMagic.
Mời bạn ghé thăm facebook nhóm - Page viết lisp theo yêu cầu  :
CAD MAGIC